<?php

// define all the events in the app

$dispatcher = Application::getEventDispatcher();

// ecouteur pour enregistrer la politique du client loggé / non loggé
$dispatcher->addListener(
    Event\AuthEvent::LOAD,
    array(new \Auth\CustomerAuth(), 'register')
);

$dispatcher->addListener(
    Event\AuthEvent::LOAD,
    array(new \Auth\BackAuth(), 'register')
);

$dispatcher->addListener(
    Event\AuthEvent::LOAD,
    array(new \Auth\RoleAuth(), 'register')
);

// ecouteur ajout panier
$dispatcher->addListener(
    Event\PanierEvent::CHANGE,
    array(new PanierHandler(), 'save')
);


// ecouteur pre render template
$dispatcher->addListener(
    Event\TemplateEvent::PRE_RENDER,
    array(new Common(), 'boot')
);

if (getenv('APP_DEBUG') && class_exists('DebugBar\\DediDebugBar')) {
    $dispatcher->addListener(
        Event\TemplateEvent::PRE_RENDER,
        array(Application::getDebugBar(), 'registerDataCollector')
    );
}

// ecouteur application terminate
$dispatcher->addListener(
    Event\ApplicationEvent::TERMINATE,
    array(new ApplicationHandler(), 'serializeStructure')
);

$dispatcher->addListener(
    Event\ApplicationEvent::BEFORE_REPSONSE,
    array(new ApplicationHandler(), 'filterResponse')
);

$dispatcher->addListener(
    Event\ApplicationEvent::BEFORE_CALL_CONTROLLER,
    array(new ApplicationHandler(), 'tracking')
);

$dispatcher->addSubscriber(new \EventListener\ReferencementListener());
$dispatcher->addSubscriber(new \EventListener\TrackingListener());