<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddCommande extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("commande", ['id' => false, 'primary_key' => ["commande_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('client_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_id', 'signed' => false])
            ->addColumn('client_civilite', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_id'])
            ->addColumn('client_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_civilite'])
            ->addColumn('client_prenom', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_nom'])
            ->addColumn('client_societe', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_prenom'])
            ->addColumn('client_rue', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_societe'])
            ->addColumn('client_rue2', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_rue'])
            ->addColumn('client_ville', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_rue2'])
            ->addColumn('client_cp', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_ville'])
            ->addColumn('client_etat', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_cp'])
            ->addColumn('client_pays', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_etat'])
            ->addColumn('client_telephone', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_pays'])
            ->addColumn('client_email', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_telephone'])
            ->addColumn('livraison_civilite', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'client_email'])
            ->addColumn('livraison_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_civilite'])
            ->addColumn('livraison_prenom', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_nom'])
            ->addColumn('livraison_societe', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_prenom'])
            ->addColumn('livraison_rue', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_societe'])
            ->addColumn('livraison_rue2', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_rue'])
            ->addColumn('livraison_ville', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_rue2'])
            ->addColumn('livraison_cp', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_ville'])
            ->addColumn('livraison_etat', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_cp'])
            ->addColumn('livraison_pays', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_etat'])
            ->addColumn('livraison_pays_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'livraison_pays', 'signed' => false])
            ->addColumn('livraison_pays_code', 'char', ['null' => false, 'default' => '', 'limit' => 3, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_pays_id'])
            ->addColumn('livraison_telephone', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_pays_code'])
            ->addColumn('relais_id', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_telephone'])
            ->addColumn('facturation_civilite', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'relais_id'])
            ->addColumn('facturation_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_civilite'])
            ->addColumn('facturation_prenom', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_nom'])
            ->addColumn('facturation_societe', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_prenom'])
            ->addColumn('facturation_rue', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_societe'])
            ->addColumn('facturation_rue2', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_rue'])
            ->addColumn('facturation_ville', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_rue2'])
            ->addColumn('facturation_cp', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_ville'])
            ->addColumn('facturation_etat', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_cp'])
            ->addColumn('facturation_pays', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_etat'])
            ->addColumn('facturation_pays_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'facturation_pays'])
            ->addColumn('facturation_pays_code', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_pays_id'])
            ->addColumn('facturation_telephone', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'facturation_pays_code'])
            ->addColumn('commande_date_modif', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'facturation_telephone'])
            ->addColumn('commande_date_ajout', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'commande_date_modif'])
            ->addColumn('commande_statut_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_date_ajout', 'signed' => false])
            ->addColumn('commande_port_ht', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'commande_statut_id'])
            ->addColumn('commande_port_taxe', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'commande_port_ht'])
            ->addColumn('commande_port_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'commande_port_taxe'])
            ->addColumn('livraison_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_port_ttc', 'signed' => false])
            ->addColumn('commande_livraison_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'livraison_id'])
            ->addColumn('commande_livraison_code', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_livraison_nom'])
            ->addColumn('commande_livraison_delai', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_livraison_code'])
            ->addColumn('commande_livraison_delai_date_min', 'date', ['null' => false, 'after' => 'commande_livraison_delai'])
            ->addColumn('commande_livraison_delai_date_max', 'date', ['null' => false, 'after' => 'commande_livraison_delai_date_min'])
            ->addColumn('commande_livraison_colis', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_livraison_delai_date_max'])
            ->addColumn('commande_livraison_info', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_livraison_colis'])
            ->addColumn('commande_facture_numero', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_livraison_info'])
            ->addColumn('commande_facture_date', 'date', ['null' => false, 'default' => '0000-00-00', 'after' => 'commande_facture_numero'])
            ->addColumn('langue_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_facture_date', 'signed' => false])
            ->addColumn('commande_commentaire', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'langue_id'])
            ->addColumn('commande_poids', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'signed' => false, 'after' => 'commande_commentaire'])
            ->addColumn('commande_taxe', 'integer', ['null' => false, 'default' => '1', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_poids'])
            ->addColumn('commande_referer', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_taxe'])
            ->addColumn('commande_stotal_ht', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'commande_referer'])
            ->addColumn('commande_stotal_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'commande_stotal_ht'])
            ->addColumn('commande_stotal_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'commande_stotal_taxe'])
            ->addColumn('commande_total_ht', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'commande_stotal_ttc'])
            ->addColumn('commande_total_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'commande_total_ht'])
            ->addColumn('commande_total_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'commande_total_taxe'])
            ->addColumn('devise_id', 'integer', ['null' => false, 'default' => '1', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_total_ttc', 'signed' => false])
            ->addForeignKey('client_id', 'client', 'client_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('commande_statut_id', 'commande_statut', 'commande_statut_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('langue_id', 'langue', 'langue_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('livraison_pays_id', 'pays', 'pays_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('livraison_id', 'livraison', 'livraison_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('devise_id', 'devise', 'devise_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['client_id'], ['name' => "client_id", 'unique' => false])
            ->addIndex(['commande_statut_id'], ['name' => "commande_statut_id", 'unique' => false])
            ->addIndex(['langue_id'], ['name' => "langue_id", 'unique' => false])
            ->addIndex(['commande_referer'], ['name' => "commande_referer", 'unique' => false])
            ->addIndex(['livraison_id'], ['name' => "livraison_id", 'unique' => false])
            ->addIndex(['livraison_pays_id'], ['name' => "livraison_pays_id", 'unique' => false])
            ->addIndex(['facturation_pays_id'], ['name' => "facturation_pays_id", 'unique' => false])
            ->addIndex(['devise_id'], ['name' => "devise_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_paiement", ['id' => false, 'primary_key' => ["commande_paiement_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_paiement_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_paiement_id', 'signed' => false])
            ->addColumn('paiement_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_id', 'signed' => false])
            ->addColumn('commande_paiement_montant', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'paiement_id'])
            ->addColumn('commande_paiement_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_paiement_montant'])
            ->addColumn('commande_paiement_code', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_paiement_nom'])
            ->addColumn('commande_paiement_statut_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_paiement_code'])
            ->addColumn('commande_paiement_date_ajout', 'datetime', ['null' => false, 'after' => 'commande_paiement_statut_id'])
            ->addColumn('commande_paiement_date_modif', 'datetime', ['null' => false, 'after' => 'commande_paiement_date_ajout'])
            ->addColumn('commande_paiement_type', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_paiement_date_modif'])
            ->addColumn('commande_paiement_ref_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_paiement_type'])
            ->addColumn('commande_paiement_operator', 'integer', ['null' => false, 'default' => '1', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_paiement_ref_id'])
            ->addForeignKey('commande_id', 'commande', 'commande_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('paiement_id', 'paiement', 'paiement_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_id'], ['name' => "commande_id", 'unique' => false])
            ->addIndex(['commande_paiement_ref_id'], ['name' => "commande_paiement_ref_id", 'unique' => false])
            ->addIndex(['commande_paiement_type'], ['name' => "commande_paiement_type", 'unique' => false])
            ->addIndex(['commande_paiement_statut_id'], ['name' => "commande_paiement_statut_id", 'unique' => false])
            ->addIndex(['paiement_id'], ['name' => "paiement_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_produit", ['id' => false, 'primary_key' => ["commande_produit_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_produit_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_produit_id', 'signed' => false])
            ->addColumn('produit_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_id', 'signed' => false])
            ->addColumn('produit_ref', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_id'])
            ->addColumn('produit_ref_frs', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_ref'])
            ->addColumn('produit_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_ref_frs'])
            ->addColumn('produit_prix', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'produit_nom'])
            ->addColumn('produit_prix_ecotaxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_prix'])
            ->addColumn('produit_achat', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'produit_prix_ecotaxe'])
            ->addColumn('produit_taxe', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'produit_achat'])
            ->addColumn('produit_quantite', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_taxe'])
            ->addColumn('produit_quantite_livrable', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_quantite'])
            ->addColumn('produit_quantite_reassort', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_quantite_livrable'])
            ->addColumn('produit_tracking', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_quantite_reassort'])
            ->addColumn('produit_prix_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_tracking'])
            ->addColumn('produit_prix_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'produit_prix_taxe'])
            ->addColumn('produit_total_ht', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_prix_ttc'])
            ->addColumn('produit_total_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_total_ht'])
            ->addColumn('produit_total_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'produit_total_taxe'])
            ->addColumn('produit_type_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_total_ttc', 'signed' => false])
            ->addForeignKey('commande_id', 'commande', 'commande_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('produit_id', 'produit', 'produit_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('produit_type_id', 'produit_type', 'produit_type_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_id'], ['name' => "commande_id", 'unique' => false])
            ->addIndex(['produit_id'], ['name' => "produit_id", 'unique' => false])
            ->addIndex(['produit_type_id'], ['name' => "produit_type_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_produit_attribut", ['id' => false, 'primary_key' => ["commande_produit_attribut_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_produit_attribut_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_produit_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_produit_attribut_id', 'signed' => false])
            ->addColumn('produit_attribut_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_produit_id', 'signed' => false])
            ->addColumn('produit_attribut_ref', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_attribut_id'])
            ->addColumn('produit_attribut_ref_frs', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_attribut_ref'])
            ->addColumn('produit_option_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_attribut_ref_frs'])
            ->addColumn('produit_option_valeur_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_option_nom'])
            ->addColumn('produit_option_valeur_prix', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_nom'])
            ->addColumn('produit_option_valeur_prix_ecotaxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_prix'])
            ->addColumn('produit_option_valeur_achat', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_prix_ecotaxe'])
            ->addColumn('produit_option_valeur_quantite', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_option_valeur_achat'])
            ->addColumn('produit_option_valeur_quantite_livrable', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_option_valeur_quantite'])
            ->addColumn('produit_option_valeur_quantite_reassort', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_option_valeur_quantite_livrable'])
            ->addColumn('produit_option_valeur_prix_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_quantite_reassort'])
            ->addColumn('produit_option_valeur_prix_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'produit_option_valeur_prix_taxe'])
            ->addColumn('produit_option_valeur_total_ht', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_prix_ttc'])
            ->addColumn('produit_option_valeur_total_taxe', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_option_valeur_total_ht'])
            ->addColumn('produit_option_valeur_total_ttc', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 2, 'after' => 'produit_option_valeur_total_taxe'])
            ->addForeignKey('commande_produit_id', 'commande_produit', 'commande_produit_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('produit_attribut_id', 'produit_attribut', 'produit_attribut_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_produit_id'], ['name' => "commande_produit_id", 'unique' => false])
            ->addIndex(['produit_attribut_id'], ['name' => "produit_attribut_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_statut_historique", ['id' => false, 'primary_key' => ["commande_statut_historique_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_statut_historique_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_historique_id', 'signed' => false])
            ->addColumn('commande_statut_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_id', 'signed' => false])
            ->addColumn('commande_statut_historique_date_ajout', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'commande_statut_id'])
            ->addForeignKey('commande_id', 'commande', 'commande_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('commande_statut_id', 'commande_statut', 'commande_statut_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_id'], ['name' => "commande_id", 'unique' => false])
            ->addIndex(['commande_statut_id'], ['name' => "commande_statut_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_statut_nom", ['id' => false, 'primary_key' => ["commande_statut_nom_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_statut_nom_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_statut_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_nom_id', 'signed' => false])
            ->addColumn('langue_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_id', 'signed' => false])
            ->addColumn('commande_statut_nom_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'langue_id'])
            ->addColumn('commande_statut_nom_sujet', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_statut_nom_nom'])
            ->addColumn('commande_statut_nom_email', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_statut_nom_sujet'])
            ->addColumn('commande_statut_nom_email_html', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_statut_nom_email'])
            ->addForeignKey('commande_statut_id', 'commande_statut', 'commande_statut_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('langue_id', 'langue', 'langue_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['langue_id', 'commande_statut_id'], ['name' => "langue_id_2", 'unique' => true])
            ->addIndex(['commande_statut_id'], ['name' => "commande_statut_id", 'unique' => false])
            ->addIndex(['langue_id'], ['name' => "langue_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_statut_option", ['id' => false, 'primary_key' => ["commande_statut_option_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_statut_option_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_statut_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_option_id', 'signed' => false])
            ->addColumn('commande_statut_option_rang', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_id'])
            ->addForeignKey('commande_statut_id', 'commande_statut', 'commande_statut_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['commande_statut_id'], ['name' => "commande_statut_id", 'unique' => false])
            ->create();

        $this
            ->table("commande_statut_option_nom", ['id' => false, 'primary_key' => ["commande_statut_option_nom_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('commande_statut_option_nom_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('commande_statut_option_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_option_nom_id', 'signed' => false])
            ->addColumn('langue_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_statut_option_id', 'signed' => false])
            ->addColumn('commande_statut_option_nom_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'langue_id'])
            ->addColumn('commande_statut_option_nom_sujet', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_statut_option_nom_nom'])
            ->addColumn('commande_statut_option_nom_email', 'text', ['null' => false, 'limit' => 65535, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'commande_statut_option_nom_sujet'])
            ->addForeignKey('commande_statut_option_id', 'commande_statut_option', 'commande_statut_option_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('langue_id', 'langue', 'langue_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addIndex(['langue_id', 'commande_statut_option_id'], ['name' => "langue_id_2", 'unique' => true])
            ->addIndex(['langue_id'], ['name' => "langue_id", 'unique' => false])
            ->addIndex(['commande_statut_option_id'], ['name' => "commande_statut_option_id", 'unique' => false])
            ->create();

        $this
            ->table("produit_stock", ['id' => false, 'primary_key' => ["produit_stock_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('produit_stock_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('produit_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_stock_id', 'signed' => false])
            ->addColumn('produit_attribut_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_id', 'signed' => false])
            ->addColumn('fournisseur_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'produit_attribut_id', 'signed' => false])
            ->addColumn('commande_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'fournisseur_id', 'signed' => false])
            ->addColumn('produit_stock_quantite', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'commande_id'])
            ->addColumn('produit_stock_libelle', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'produit_stock_quantite'])
            ->addColumn('produit_stock_prix_ht', 'decimal', ['null' => false, 'precision' => 15, 'scale' => 4, 'after' => 'produit_stock_libelle'])
            ->addColumn('produit_stock_date_ajout', 'datetime', ['null' => false, 'after' => 'produit_stock_prix_ht'])
            ->addColumn('produit_stock_date_modif', 'datetime', ['null' => false, 'after' => 'produit_stock_date_ajout'])
            ->addForeignKey('produit_id', 'produit', 'produit_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('produit_attribut_id', 'produit_attribut', 'produit_attribut_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('fournisseur_id', 'fournisseur', 'fournisseur_id', array(
                'delete' => 'SET NULL',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('commande_id', 'commande', 'commande_id', array(
                'delete' => 'SET NULL',
                'update' => 'CASCADE'
            ))
            ->addIndex(['fournisseur_id'], ['name' => "fournisseur_id", 'unique' => false])
            ->addIndex(['produit_id'], ['name' => "produit_id", 'unique' => false])
            ->addIndex(['produit_attribut_id'], ['name' => "produit_attribut_id", 'unique' => false])
            ->addIndex(['commande_id'], ['name' => "commande_id", 'unique' => false])
            ->create();
    }
}
