<?php

namespace Controller;

use Breadcrumb;
use Cms;
use Symfony\Component\Routing\Annotation\Route;

// TODO : to remove => use router SF
use Link;

/**
 * Class CmsController
 * @package Controller
 *
 * @Route("")
 */
class CmsController extends Controller
{

    /**
     * @Route(
     *      path         = "/p-{page_nom_url}.html",
     *      name         = "page",
     *      requirements = { "page_nom_url" = "[a-zA-Z0-9-_]+" }
     * )
     *
     * @return mixed
     *
     * @throws \SmartyException
     */
    public function show()
    {

        $parameters = $this->request->attributes->all();
        $tpl_vars = array();

        $contenu = new Cms;

        // @TODO : a revoir

        // Si on a pas de contenu pour la page courant, c'est que c'est une erreur 404
        $ifExist = $contenu->getMenu($parameters);
        if (empty($ifExist)) {
            header("Refresh: 0; url=/", false, 404);
            exit;
        }

        $arrContenu = $contenu->get($parameters);

        if (!empty($arrContenu)) {
            $tpl_vars['contenu'] = $arrContenu[0];

            // On d�finis les id de la page courante
            $currentMenuId = $arrContenu[0]['cms_menu_id'];
            $currentPageId = $arrContenu[0]['cms_page_id'];

            // Test si la page a un parent
            $isChild = $contenu->isChild($currentPageId);
        } else {
            $isChild = true;
        }

        if ($isChild) {
            // Conseils
            $arrContenu = $contenu->getPageAssoc($parameters);

            // $arrContenu[0]['page_nom_contenu'] = fetchTPL($arrContenu[0]['page_nom_contenu'], $smarty);
            $tpl_vars['contenu'] = $arrContenu[0];
            if (!empty($currentPageId))
                $formChild['parent_id'] = $currentPageId;
            else
                $formChild['parent_id'] = $arrContenu[0]['parent_id'];

            $childExist = $contenu->getMenu($formChild);

            $tpl_vars['menupage'] = $childExist;
            $tpl_vars['is_ssmenu'] = 1;
        }else {
            // Generation du menu droit dans le cas où les pages sont toutes parentes
            $formvars['menu_id'] = $currentMenuId;
            $arrMenu = $contenu->get($formvars);
            $tpl_vars['menupage'] = $arrMenu;
        }

        if (!empty($arrContenu[0]['parent_id'])) {
            $parent_menu = $contenu->get(array('cms_page_id' => $arrContenu[0]['parent_id']));
            $tpl_vars['parent_menu'] = $parent_menu[0];
        }

        $bc = Breadcrumb::getInstance();
        $bc->add(
            $arrContenu[0]['page_nom_nom'],
            $this->generateUrl('page', array('page_nom_url' => $arrContenu[0]['page_nom_url']))
        );
        //-- ARIANNE

        // Referencement
        if (!empty($arrContenu[0]['page_nom_meta_title']))
            $ref['title'] = $arrContenu[0]['page_nom_meta_title'];
        else
            $ref['title'] = $arrContenu[0]['page_nom_nom'];
        if (!empty($arrContenu[0]['page_nom_meta_desc']))
            $ref['description'] = $arrContenu[0]['page_nom_meta_desc'];
        else
            $ref['description'] = $arrContenu[0]['page_nom_nom'];
        if (!empty($arrContenu[0]['page_nom_meta_keyword']))
            $ref['keywords'] = $arrContenu[0]['page_nom_meta_keyword'];
        else
            $ref['keywords'] = $arrContenu[0]['page_nom_nom'];
        if (!empty($arrContenu[0]['page_nom_meta_other']))
            $ref['other'] = $arrContenu[0]['page_nom_meta_other'];
        else
            $ref['other'] = $arrContenu[0]['page_nom_nom'];

        $tpl_vars['ref'] = $ref;

        $this->template->loadFilter('output', 'fetch_tpl');

        return $this->render('cms.tpl', $tpl_vars);
    }
}