{extends file="layout/layout.tpl"}

{block name="script"}
    <script src="{$themeFolder}/js/jquery.popup.js"></script>
    <script src="{$themeFolder}/js/elevateZoom.js"></script>
{/block}

{block name="content"}

<div class="container">
    <div class="breadcrumbs">{Breadcrumb::getInstance()->render()}</div>

    <div class="product-detail">
        <input type="hidden" name="produitID" value="{$p.produit_id}" />
        <input type="hidden" name="txtQuantiteTitle" value="{txt value="Quantité"}" />
        <input type="hidden" name="priceFormat" value="{{price ttc=0}|strip_tags}" />
        <h1 class="product-name bottom-grey-border tel">{$p.produit_nom_nom}</h1>
        <p class="reference mobile">
            <strong>{txt value='Référence'}: {$p.produit_ref}</strong>
        </p>
        <div class="product-image">
            {image src=$p.produit_image alt=$p.produit_nom_nom width=340 height=400 id="img_01" data-zoom-image="{image src=$p.produit_image width=1024 height=1024 tag=false}"}
            <div id="gallery_01" class="product-images">
                {foreach $arrImage as $image}
                    <div class="small-image">
                        <a href="#" class="active" data-image='{image src=$image.produit_image width=340 height=400 id=$image.image_id tag=false}' data-zoom-image='{image src=$image.produit_image width=1024 height=1024 tag=false}'>
                            {image src=$image.produit_image alt=$image.produit_image_nom width=40 height=70 id=$image.image_id}
                        </a>
                    </div>
                {/foreach}
            </div>
        </div>

        <div class="product-info">
            <h1 class="product-name bottom-grey-border">{$p.produit_nom_nom}</h1>

            <p class="reference">
              <strong>{txt value='Référence'}: {$p.produit_ref}</strong>
            </p>

            <h2>
                {if !empty($attributsTaille) && count($attributsTaille) == 1}
                    {txt value='Indiquez la quantité souhaitée'}
                {else}
                    {txt value='Indiquez la quantité souhaitée par taille'}
                {/if}
            </h2>

            <form name="add-panier" action="{url page='add_cart'}" method="post">
                <div class="sizes-info">
                    {if !empty($attributsTaille) && count($attributsTaille) >1}
                    <p><a href="{url page='page' page_nom_url='guide-des-tailles'}">Guide des tailles</a></p>
                    {/if}

                    {if !empty($attributsTaille)}
                        <div class="sizes">
                            {foreach $attributsTaille as $attribut}
                                <input type="hidden" name="attribut_option_nom[{$attribut.produit_attribut_id}]" value="{$attribut.produit_option_nom}" />
                                <label class="label-size{if $attribut.produit_attribut_quantite <= 0} unavailable{/if}">
                                    {$attribut.produit_option_valeur_nom}
                                    <input class="attribute-size" name="attribut[{$attribut.produit_attribut_id}]" type="number" {if $attribut.produit_attribut_quantite > 0}placeholder="0"{/if} size="3" min="0" max="{$attribut.produit_attribut_quantite}"{if $attribut.produit_attribut_quantite <= 0} disabled="disabled" readonly="readonly"{/if} />
                                </label>
                            {/foreach}
                        </div>
                    {/if}
                </div>

                {if !empty($attributsCouleur)}
                    <h2>{txt value='Sélectionnez votre couleur'}</h2>
                    <span class="colors-label">{$attributsCouleur[0].produit_option_nom}</span>
                    <select class="form-control" name="attribut[{$attribut[0].produit_option_id}]" id="colors">
                        {foreach $attributsCouleur as $attribut}
                            <option value="{$attribut.produit_option_valeur_id}">{$attribut.produit_option_valeur_nom}</option>
                        {/foreach}
                    </select>
                {/if}
            </form>

            <div class="actions mobile">
                <div class="cart-block">
                    {if $gamme_flash_sales_id == $p.gamme_id && $p.promo|intval > 0}
                        <div class="flash-sale-info-wrapper">
                            <div class="flash-sale flash-sale-info full-width" rel="{$p.produit_prix_barre_date_fin}">
                                <div class="title">{$p.etiquette_nom_nom}</div>
                            </div>
                        </div>
                    {/if}

                    {if $p.promo|intval > 0}
                        <div class="promotion">
                            {txt value='Promotion'} -{$p.promo_percent}%
                        </div>
                    {/if}

                    <div class="price-block">
                        <div class="prices">
                            {if $p.promo|intval > 0}
                                <div class="old-price">
                                    {{price ttc=$p.attribut_prix_ttc}|strip_tags}
                                </div>
                            {/if}
                            <div class="current-price">
                                {{price ht=$p.attribut_produit_prix_ht ttc=$p.attribut_produit_prix_ttc}|strip_tags}
                            </div>
                        </div>

                        <div class="stock-info in-stock">
                            <span class="stock-count">{$p.produit_quantite}</span> {txt value='articles disponibles'}
                        </div>

                        <button name="addToCart" type="submit" class="btn btn-add-to-cart add-panier" data-form="add-panier-{$p.produit_id}" data-toggle="modal" data-target="#modal-panier">
                            {txt value='Ajouter au panier'}
                        </button>
                    </div>
                </div>

                <div class="alert-block">
                    {*<div class="alert-title">*}
                    <button class="btn collapsed alert-title" data-toggle="collapse" data-target="#view-alert">
                        {txt value='Alerte email !'}
                    </button>
                    {*</div>*}
                    <div class="collapse alert-form" id="view-alert">
                    {*<div class="alert-form">*}
                        <p>{txt value='Envoyez-moi un email lorsque ce produit est de nouveau en stock'} :</p>

                        <form action="{url page="produit_alerte_add"}" method="post" data-ajax data-event="processProduitAlerte">
                            <select name="produit_attribut_id" class="form-control size-select" name="size" id="">
                            {if !empty($attributsTaille)}
                                <select class="form-control size-select" name="size" id="">
                                    <option value="">Taille</option>
                                    {foreach $attributsTaille as $attribut}
                                        <option value="{$attribut.produit_attribut_id}">{$attribut.produit_option_valeur_nom}</option>
                                    {/foreach}
                                </select>
                            {/if}
                            <div class="input-group">
                                <input name="client_email" type="text" class="form-control" placeholder="{txt value="Votre email"}" value=""/>
                                <span class="input-group-btn">
                                    <input type="submit" value="{txt value="OK"}" class="btn btn-default"/>
                                </span>
                            </div>
                        </form>
                    </div>
                </div>
            </div>

            <div class="tabs">
                <!-- Nav tabs -->
                <ul class="nav nav-tabs bottom-grey-border" role="tablist" id="product-tablist">
                    <li role="presentation" class="active">
                        <a href="#home" aria-controls="home" role="tab" data-toggle="tab">{txt value='Description'}</a>
                    </li>
                    {if !empty($cmsLinks)}
                        <li role="presentation">
                            <a href="#cmsLink1" aria-controls="cmsLink1" role="tab" data-toggle="tab">{txt value='Paiement'}</a>
                        </li>
                        <li role="presentation">
                            <a href="#cmsLink2" aria-controls="cmsLink2" role="tab" data-toggle="tab">{txt value='Livraison'}</a>
                        </li>
                        <li role="presentation">
                            <a href="#cmsLink3" aria-controls="cmsLink3" role="tab" data-toggle="tab">{txt value='Retour'}</a>
                        </li>
                    {/if}
                </ul>

                <!-- Tab panes -->
                <div class="tab-content">
                    <div role="tabpanel" class="tab-pane active" id="home">
                        {$p.produit_nom_desc}
                    </div>
                    {if !empty($cmsLinks)}
                        {foreach $cmsLinks as $k => $cmsLink}
                            <div role="tabpanel" class="tab-pane" id="cmsLink{$k}">
                                {$cmsLink.page_nom_contenu}
                            </div>
                        {/foreach}
                    {/if}
                </div>

            </div>

        </div>

        <div class="actions">
            <div class="cart-block">
                {if !empty($p.gammes)}
                    {foreach $p.gammes as $k => $gamme}
                        {if $gamme_flash_sales_id == $gamme.gamme_id && $p.promo|intval > 0}
                            <div class="flash-sale-info-wrapper">
                                <div class="flash-sale flash-sale-info full-width" rel="{$p.produit_prix_barre_date_fin}">
                                    <div class="title">{$p.etiquette_nom_nom}</div>
                                </div>
                            </div>
                        {/if}
                    {/foreach}
                {/if}

                {if $p.promo|intval > 0}
                <div class="promotion">
                    {txt value='Promotion'}  -{$p.promo_percent}%
                </div>
                {/if}

                <div class="price-block">
                    <div class="prices">
                        {if $p.promo|intval > 0}
                            <div class="old-price">
                                {{price ttc=$p.attribut_prix_ttc}|strip_tags}
                            </div>
                        {/if}
                        <div class="current-price">
                            {{price ht=$p.attribut_produit_prix_ht ttc=$p.attribut_produit_prix_ttc}|strip_tags}
                        </div>
                    </div>

                    <div class="stock-info in-stock">
                        <span class="stock-count">{$p.produit_quantite}</span> {txt value='articles disponibles'}
                    </div>

                    <button name="addToCart" type="submit" class="btn btn-add-to-cart add-panier" data-form="add-panier-{$p.produit_id}">
                        {txt value='Ajouter au panier'}
                    </button>
                </div>
            </div>

            <div class="alert-block">
                <div class="alert-title">
                    {txt value='Alerte email !'}
                </div>
                <div class="alert-form">
                    <p>{txt value='Envoyez-moi un email lorsque ce produit est de nouveau en stock'} :</p>
                    <p class="error"></p>
                    <form action="{url page="produit_alerte_add"}" method="post" data-ajax data-event="processProduitAlerte">
                        <input type="hidden" name="produit_id" value="{$p.produit_id}" />
                        {if !empty($attributsTaille) && count($attributsTaille) > 1}
                            <select name="produit_attribut_id" class="form-control size-select" name="size" id="">
                                <option value="">Taille</option>
                                {foreach $attributsTaille as $attribut}
                                    <option value="{$attribut.produit_attribut_id}">{$attribut.produit_option_valeur_nom}</option>
                                {/foreach}
                            </select>
                        {elseif !empty($attributsTaille) && count($attributsTaille) <= 1}
                            {foreach $attributsTaille as $attribut}
                                <input type="hidden" name="produit_attribut_id" value="{$attribut.produit_attribut_id}">
                            {/foreach}
                        {/if}
                        <div class="input-group">
                            <input name="client_email" type="text" class="form-control" placeholder="{txt value="Votre email"}" value=""/>
                            <span class="input-group-btn">
                                <input type="submit" value="{txt value="OK"}" class="btn btn-default"/>
                            </span>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <div class="related-products">
        <h1 class="bottom-grey-border">Produits associés</h1>

        <div class="products carousel-slick">
            {foreach $arrAssoc as $produit}
                {include file="produit/listing.tpl" p=$produit}
            {foreachelse}
                <p class="related-products-no-results-text">
                    {txt value='Aucun produit associé'}
                </p>
            {/foreach}
        </div>
    </div>
</div>

<div class="modal fade" id="modal-panier" tabindex="-1" role="dialog" aria-labelledby="modalPanierLabel">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true"></span></button>
                <div class="modal-title" id="modalPanierLabel">{txt value='vous venez d’ajouter à votre panier'}</div>
            </div>
            <div class="modal-body">
                <div class="item">
                    <div class="image">
                        <a href="#">
                            {image class="img-responsive" src=$p.produit_image alt=$p.produit_nom_nom width=340 height=400 id="img_01" data-zoom-image="{image src=$p.produit_image width=1024 height=1024 tag=false}"}
                        </a>
                    </div>
                    <div class="information">
                        <div class="name">{$p.produit_nom_nom}</div>
                        <div class="size"></div>
                        <div class="quantity"></div>
                        <div class="color"></div>
                        <div class="stock"></div>
                    </div>
                    <div class="item-prices">
                        <div class="old-price"></div>
                        <div class="price"></div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button id="continueShop" type="button" class="btn btn-white" data-dismiss="modal">{txt value='Poursuivre mes achats'}</button>
                <a href="{url page='panier'}" class="btn btn-red">{txt value='Voir mon panier'}</a>
            </div>
        </div>
    </div>
</div>

{/block}
{block name="script-js"}
    <script type="text/javascript">
        var itemCart = null;


        jQuery("#continueShop").click(function(){
            location.reload();
        });

        jQuery("#modal-panier").click(function(){
            location.reload();
        });

        jQuery(document).ready(function(){
            $("#img_01").elevateZoom({
                gallery:'gallery_01',
                cursor: 'pointer',
                galleryActiveClass: 'active',
                imageCrossfade: false
            });
            $("#gal").bind("click", function(e) {
                var ez = $('#gal1').data('elevateZoom');
                $.fancybox(ez.getGalleryList());
                return false;
            });


//            initZoomProduit('img_grand-visuel_1', 'thumbs_1');
//            initZoomProduit('img_grand-visuel_2', 'thumbs_2');
            itemCart = $('#modal-panier').find('.item').eq(0);
            $(itemCart).hide();

            jQuery(document).on('click', 'button[name="addToCart"]', function(event){
                event.preventDefault();
                var that = this;
                var tmpForm = null;
                var hasQuantity = false;
                if($('input.attribute-size').length > 0){

                    $('.modal-body > .item').each(function(i,e) {
                        if(i > 0){
                            $(e).remove();
                        }
                    });

                    $('input.attribute-size').each(function(i,e) {

                        if(parseInt($(e).val()) >= parseInt($(e).attr('max'))){
                            alert($(e).parent().text().trim() + ' : Quantité trop importante');
                            return false;
                        } else if(parseInt($(e).val()) > 0){
                            tmpForm = document.createElement('form');
                            tmpForm.setAttribute('action', $('form[name=add-panier]').attr('action'));

                            var produitID = $('input[name=produitID]').val();
                            var tmpProduitIDInput = document.createElement('input');
                            tmpProduitIDInput.setAttribute('type', 'hidden');
                            tmpProduitIDInput.setAttribute('name', 'produit_id');
                            tmpProduitIDInput.setAttribute('value', produitID);
                            tmpForm.appendChild(tmpProduitIDInput);

                            var startSubstrAttributID = $(e).attr('name').toString().indexOf('[') + 1;
                            var endSubstrAttributID = $(e).attr('name').toString().indexOf(']');
                            var diffSubstrAttributID = endSubstrAttributID - startSubstrAttributID;
                            var attributID = parseInt($(e).attr('name').toString().substr(startSubstrAttributID, diffSubstrAttributID));
                            var tmpProduitAttributIDInput = document.createElement('input');
                            tmpProduitAttributIDInput.setAttribute('type', 'hidden');
                            tmpProduitAttributIDInput.setAttribute('name', 'produit_attribut_id');
                            tmpProduitAttributIDInput.setAttribute('value', attributID);
                            tmpForm.appendChild(tmpProduitAttributIDInput);

                            var tmpProduitAttributQuantiteInput = document.createElement('input');
                            tmpProduitAttributQuantiteInput.setAttribute('type', 'hidden');
                            tmpProduitAttributQuantiteInput.setAttribute('name', 'quantite');
                            tmpProduitAttributQuantiteInput.setAttribute('value', parseInt($(e).val()));
                            tmpForm.appendChild(tmpProduitAttributQuantiteInput);

                            hasQuantity = true;

                            var textAttribut = $(e).parent().text().trim();

                            if(new Panier().add($(tmpForm))){
                                $(itemCart).find('.image > a > img').remove();
                                $(itemCart).find('.image > a').append($('.product-image > img').clone());

                                var attributOptionNom = $('input[name="attribut_option_nom[' + attributID + ']"').val();
                                var quantity = parseInt($(e).val());
                                $(itemCart).find('.size').html(attributOptionNom + ': ' + textAttribut);
                                $(itemCart).find('.quantity').html($('input[name=txtQuantiteTitle]').val() + ': ' + quantity);

                                var oldPrice = 0;
                                if($('.prices > .old-price').length > 0){
                                    oldPrice = $('.prices > .old-price').eq(0).html().trim();
                                    oldPrice = oldPrice.replace(',', '.').replace(' ', '');
                                    oldPrice = parseFloat(oldPrice);
                                    oldPrice *= quantity;
                                    oldPrice = number_format(oldPrice, 2, ', ', '');
                                }

                                var price = $('.prices > .current-price').eq(0).html().trim();
                                price = price.replace(',', '.').replace(' ', '');
                                price = parseFloat(price);
                                price *= quantity;
                                price = number_format(price, 2, ', ', '');

                                if(price != oldPrice  && oldPrice != 0){
                                    var newOldPrice = $('input[name=priceFormat]').val().replace('0, 00', oldPrice);
                                    $(itemCart).find('.old-price').html(newOldPrice).show();
                                } else {
                                    $(itemCart).find('.old-price').hide();
                                }
                                var newPrice = $('input[name=priceFormat]').val().replace('0, 00', price);
                                $(itemCart).find('.price').html(newPrice);

                                var newItemCart = $(itemCart).clone();
                                $(newItemCart).show().insertAfter($('.modal-body > .item').eq($('.modal-body > .item').length-1));
                            }

                        }
                    });
                    tmpForm = null;
                    if(!hasQuantity){
                        alert('Veuillez renseigner une quantité par taille désirée');
                        return false;
                    } else {
                        $("#modal-panier").modal("toggle");
                    }
                } else {
                    //new Panier().add(jQuery(that));
                }
                return false;
            });

            jQuery(document).on('change', 'select[name="quantite"]', function(event){
                // event.preventDefault();
                $.ajax({
                    type: "POST",
                    url: "{url page="select_quantity"}",
                    dataType: 'json',
                    data: 'produit_id=' + $('#produit_id').val() + '&quantity=' + $(this).val(),
                    success: function (data) {
                        dataBind(data);
                        $('#produit_attribut_id').val(data.att_id);
                    }
                });
            });

            $(document).on('processProduitAlerte', function(JSONData) {
                var response = $.parseJSON(JSONData.details);
                console.log(response);
                if(response.errors != undefined){
                    $('.alert-block').find('.error').html(response.errors.join('<br />'));
                } else {
                    $('.alert-block').find('.error').html(response.valid);
                }
                return false;
            });
        });
    </script>
{/block}
