$(document).ready(function(){
    // data-submit
    $(document).on('click', 'button[data-submit]', function(event){
        $(this).parents('form').submit();
    });

    // ajax post form
    $(document).on('submit', 'form[data-ajax]', function(event){
        event.preventDefault();
        var eventType = ($(this).data('event')) ? $(this).data('event') : 'submit-form';
        var node = this;
        $.ajax({
            type: $(this).attr('method'),
            url: $(this).attr('action'),
            dataType: ($(this).data('type')) ? $(this).data('type') : 'html',
            data: $(this).serialize(),
            beforeSend: function() {
                createLoader(node);
            },
            complete: function(){
                destructLoader(node);
            },
            success: function (data) {
                var event = $.Event(eventType);
                event.details = data;
                $(document).trigger(event);
            }
        });
    });
});

function createLoader(node)
{
    $(node).append($('<div class="loader uk-vertical-align uk-text-center"><div class="uk-vertical-align-middle"><i class="uk-icon-spinner uk-icon-spin uk-icon-large"></i></div></div>'));
}

function destructLoader(node)
{
    $(node).find('.loader').remove();
}

function dataBind(data, prefixe)
{
    if (prefixe == undefined) {
        prefixe = '';
    }
    $.each(data, function( index, value ) {
        // $('*[data-' + prefixe + index + ']').html(value);
        $('*[data-' + prefixe + index + ']').each(function( elmt ){
            if ($(this).is('input')) {
                $(this).val(value);
            } else {
                $(this).html(value);
            }
        });
    });
}